Attribute VB_Name = "mMisc"
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" ( _
        ByRef Destination As Any, ByRef Source As Any, ByVal Length As Long)
Public Declare Sub ZeroMemory Lib "kernel32" Alias "RtlZeroMemory" ( _
        ByRef Address As Any, ByVal Length As Long)
Public Declare Function QueryDosDevice Lib "KERNEL32.DLL" _
        Alias "QueryDosDeviceA" _
        (ByVal device As String, ByVal Path As String, ByVal Length As Long) As Long
Public Declare Function GetDriveType Lib "kernel32" Alias "GetDriveTypeA" (ByVal sDrive As String) As Long
Private Declare Function GetVolumeInformation Lib "kernel32" Alias "GetVolumeInformationA" (ByVal lpRootPathName As String, ByVal lpVolumeNameBuffer As String, ByVal nVolumeNameSize As Long, lpVolumeSerialNumber As Long, lpMaximumComponentLength As Long, lpFileSystemFlags As Long, ByVal lpFileSystemNameBuffer As String, ByVal nFileSystemNameSize As Long) As Long
Private Declare Function GetDiskFreeSpaceEx Lib "kernel32" Alias "GetDiskFreeSpaceExA" (ByVal lpDirectoryName As String, lpFreeBytesAvailableToCaller As Currency, lpTotalNumberOfBytes As Currency, lpTotalNumberOfFreeBytes As Currency) As Long
Private Declare Function StrFormatByteSize Lib "Shlwapi" Alias "StrFormatByteSizeW" (ByVal dw As Currency, ByVal pszBuf As Long, ByVal cchBuf As Long) As Long
Private Declare Function lstrlenW Lib "kernel32" (ByVal lpString As Long) As Long

Public Const DRIVE_CDROM = 5
Dim Power2(31) As Double

Public Function TrimNull(ByVal startstr As String) As String
   Dim pos As Integer
   pos = InStr(startstr, Chr$(0))
   If pos Then
      TrimNull = Left$(startstr, pos - 1)
      Exit Function
   End If
   TrimNull = startstr
End Function

Public Function BE_UINT(Bytes() As Byte) As Long 'Make UINT from 2 bytes in BIG_ENDIAN notattion
   BE_UINT = Bytes(0) * 256 + Bytes(1)
End Function

Public Function LE_UINT(Bytes() As Byte) As Long 'Make UINT from 2 bytes in LITTLE_ENDIAN notattion
   LE_UINT = Bytes(1) * 256 + Bytes(0)
End Function

Public Function BE_ULONG(Bytes() As Byte) As Double 'Make ULONG from 4 bytes in BIG_ENDIAN notattion
   If Power2(0) = 0 Then InitPower2
   BE_ULONG = Bytes(0) * Power2(24) + Bytes(1) * Power2(16) + Bytes(2) * Power2(8) + Bytes(3)
End Function

Public Function LE_ULONG(Bytes() As Byte) As Double 'Make ULONG from 4 bytes in LITTLE_ENDIAN notattion
   If Power2(0) = 0 Then InitPower2
   LE_ULONG = Bytes(3) * Power2(24) + Bytes(2) * Power2(16) + Bytes(1) * Power2(8) + Bytes(0)
End Function

Public Function Min(ByVal a As Double, ByVal b As Double) As Double
   Min = IIf(a > b, b, a)
End Function

Public Function Max(ByVal a As Double, ByVal b As Double) As Double
   Max = IIf(a < b, b, a)
End Function

Public Function IsBitSetByte(ByVal iBitString As Byte, ByVal lBitNo As Integer) As Boolean
   If Power2(0) = 0 Then InitPower2
   IsBitSetByte = iBitString And (2 ^ lBitNo)
End Function

Public Function LShift(ByVal lValue As Long, ByVal lNumberOfBitsToShift As Long) As Long
   If Power2(0) = 0 Then InitPower2
   LShift = lValue * Power2(lNumberOfBitsToShift)
End Function

Public Function RShift(ByVal lValue As Long, ByVal lNumberOfBitsToShift As Long) As Long
   If Power2(0) = 0 Then InitPower2
   RShift = lValue \ Power2(lNumberOfBitsToShift)
End Function

Public Function YesNoBoolean(ByVal bVal As Boolean) As String
    YesNoBoolean = IIf(bVal, "Yes", "No")
End Function

Public Function GetVolumeInfo(ByVal sRootPath As String, _
                 VolumeLabel As String, _
                 VolumeSerial As String, _
                 FileSystem As String) As Boolean
   Dim lVolumeSerial As Long, lTemp As Long, lFlags As Long, ret As Boolean
   
   If sRootPath = "" Or sRootPath = vbNullString Then Exit Function
   sRootPath = Left(sRootPath, 1) & ":\"
   VolumeLabel = String(255, 0)
   FileSystem = String(255, 0)
   ret = CBool(GetVolumeInformation(sRootPath, VolumeLabel, Len(VolumeLabel), lVolumeSerial, lTemp, lFlags, FileSystem, Len(FileSystem)))
   FileSystem = TrimNull(FileSystem)
   s = "Not available"
   If FileSystem = "" Then FileSystem = s
   VolumeLabel = TrimNull(VolumeLabel)
   If VolumeLabel = "" Then VolumeLabel = s
   If lVolumeSerial Then
      s = Right("00000000" & Hex(lVolumeSerial), 8)
      s = Left(s, 4) & "-" & Right(s, 4)
   End If
   VolumeSerial = s
   GetVolumeInfo = ret
End Function

Public Function FormatByteSize(ByVal Bytes As Currency) As String
   Dim strBuff As String * 256
   Dim nRet As Long
   nRet = StrFormatByteSize(Bytes / 10000, StrPtr(strBuff), 256)
   If nRet Then FormatByteSize = Ptr2StrU(nRet)
End Function

Private Function Ptr2StrU(ByVal pAddr As Long) As String
   Dim lAddr As Long: lAddr = lstrlenW(pAddr)
   Ptr2StrU = Space$(lAddr)
   CopyMemory ByVal StrPtr(Ptr2StrU), ByVal pAddr, lAddr * 2
End Function

Private Sub InitPower2()
   Dim i As Long
   For i = 0 To 31
       Power2(i) = 2 ^ i
   Next i
End Sub

Public Function ZeroPad(ByVal strIn As String, ByVal nLength As Long) As String
   ZeroPad = Right(String(nLength, "0") & strIn, nLength)
End Function

Public Function HMSFToString(x As HMSF) As String
   HMSFToString = ZeroPad(x.h, 2) & ":" & ZeroPad(x.m, 2) & ":" & _
                  ZeroPad(x.s, 2) & "." & ZeroPad(x.f, 2)
End Function

Public Function DoubleToHMSF(ByVal dblVal As Double) As HMSF
   Dim h As Long, m As Long, s As Long, f As Long, t As Long
   dblVal = Int(dblVal)
   t = Int(dblVal / 75)
   f = dblVal - t * 75
   h = Int(t / 3600)
   m = Int((t - h * 3600) / 60)
   s = t - h * 3600 - m * 60
   If h = 1 Then
      If h * 60 + m < 100 Then
         h = 0: m = m + 60
      End If
   End If
   DoubleToHMSF.h = h
   DoubleToHMSF.m = m
   DoubleToHMSF.s = s
   DoubleToHMSF.f = f
End Function

